import { RequestOptionsFactory } from '@wix/sdk-types';
/**
 * Start an async job to retrieve a list of session IDs, given the specified filters. The following filters **must** be passed:
 * - Time period, either predefined or custom.
 * - Session filter, either navigation flow (page interactions), conversion funnel steps, or device type.
 */
export declare function listSessionsAsync(payload: object): RequestOptionsFactory<any>;
/** Retrieves the job status and a list of session IDs, if ready. */
export declare function getListSessionsJobResult(payload: object): RequestOptionsFactory<any>;
/** Marks a browser session as recorded. */
export declare function markSessionAsRecorded(payload: object): RequestOptionsFactory<any>;
/** Marks browser session recordings as deleted. */
export declare function markRecordingsAsDeleted(payload: object): RequestOptionsFactory<any>;
