"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JobStatus = exports.DeviceType = exports.FunnelStep = exports.PredefinedTimePeriod = void 0;
/**
 * Predefined time period.
 * `THIS_WEEK`begins with Monday.
 */
var PredefinedTimePeriod;
(function (PredefinedTimePeriod) {
    /** Today. */
    PredefinedTimePeriod["TODAY"] = "TODAY";
    /** Yesterday. */
    PredefinedTimePeriod["YESTERDAY"] = "YESTERDAY";
    /** Last 7 days. */
    PredefinedTimePeriod["LAST_7_DAYS"] = "LAST_7_DAYS";
    /** Last 14 days. */
    PredefinedTimePeriod["LAST_14_DAYS"] = "LAST_14_DAYS";
    /** Last 30 days. */
    PredefinedTimePeriod["LAST_30_DAYS"] = "LAST_30_DAYS";
    /** Last 90 days. */
    PredefinedTimePeriod["LAST_90_DAYS"] = "LAST_90_DAYS";
    /** Last 28 days. */
    PredefinedTimePeriod["LAST_28_DAYS"] = "LAST_28_DAYS";
    /** Last 180 days. */
    PredefinedTimePeriod["LAST_180_DAYS"] = "LAST_180_DAYS";
    /** Last 365 days. */
    PredefinedTimePeriod["LAST_365_DAYS"] = "LAST_365_DAYS";
    /** Current week, starting on Monday. */
    PredefinedTimePeriod["THIS_WEEK"] = "THIS_WEEK";
    /** Current month. */
    PredefinedTimePeriod["THIS_MONTH"] = "THIS_MONTH";
    /** Current quarter. */
    PredefinedTimePeriod["THIS_QUARTER"] = "THIS_QUARTER";
    /** This year. */
    PredefinedTimePeriod["THIS_YEAR"] = "THIS_YEAR";
    /** Last week (previous week). */
    PredefinedTimePeriod["LAST_WEEK"] = "LAST_WEEK";
    /** Last month. */
    PredefinedTimePeriod["LAST_MONTH"] = "LAST_MONTH";
    /** Last quarter. */
    PredefinedTimePeriod["LAST_QUARTER"] = "LAST_QUARTER";
    /** Last year. */
    PredefinedTimePeriod["LAST_YEAR"] = "LAST_YEAR";
    /** Last 12 months. */
    PredefinedTimePeriod["LAST_12_MONTHS"] = "LAST_12_MONTHS";
})(PredefinedTimePeriod || (exports.PredefinedTimePeriod = PredefinedTimePeriod = {}));
/** Funnel step. */
var FunnelStep;
(function (FunnelStep) {
    /** Not selected. */
    FunnelStep["NOT_SELECTED_FUNNEL_STEP"] = "NOT_SELECTED_FUNNEL_STEP";
    /** Site sessions. */
    FunnelStep["SITE_SESSIONS"] = "SITE_SESSIONS";
    /** Viewed product. */
    FunnelStep["VIEWED_PRODUCT"] = "VIEWED_PRODUCT";
    /** Added to cart. */
    FunnelStep["ADDED_TO_CART"] = "ADDED_TO_CART";
    /** Reached checkout. */
    FunnelStep["REACHED_CHECKOUT"] = "REACHED_CHECKOUT";
    /** Sessions converted. */
    FunnelStep["SESSIONS_CONVERTED"] = "SESSIONS_CONVERTED";
})(FunnelStep || (exports.FunnelStep = FunnelStep = {}));
/** Device type. */
var DeviceType;
(function (DeviceType) {
    /** Not selected. */
    DeviceType["NOT_SELECTED_DEVICE_TYPE"] = "NOT_SELECTED_DEVICE_TYPE";
    /** Desktop. */
    DeviceType["DESKTOP"] = "DESKTOP";
    /** Mobile. */
    DeviceType["MOBILE"] = "MOBILE";
    /** Tablet. */
    DeviceType["TABLET"] = "TABLET";
    /** All. */
    DeviceType["ALL"] = "ALL";
})(DeviceType || (exports.DeviceType = DeviceType = {}));
/** Job status. */
var JobStatus;
(function (JobStatus) {
    /** Unknown. */
    JobStatus["UNKNOWN_JOB_STATUS"] = "UNKNOWN_JOB_STATUS";
    /** In progress. */
    JobStatus["IN_PROGRESS"] = "IN_PROGRESS";
    /** Finished. */
    JobStatus["FINISHED"] = "FINISHED";
    /** Error. */
    JobStatus["ERROR"] = "ERROR";
})(JobStatus || (exports.JobStatus = JobStatus = {}));
//# sourceMappingURL=analytics-ng-v1-session-analytics-session.types.js.map