"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.markRecordingsAsDeleted = exports.markSessionAsRecorded = exports.getListSessionsJobResult = exports.listSessionsAsync = exports.JobStatus = exports.DeviceType = exports.FunnelStep = exports.PredefinedTimePeriod = void 0;
const transform_error_1 = require("@wix/sdk-runtime/transform-error");
const rename_all_nested_keys_1 = require("@wix/sdk-runtime/rename-all-nested-keys");
const ambassadorWixAnalyticsNgV1Session = __importStar(require("./analytics-ng-v1-session-analytics-session.http.js"));
/**
 * Predefined time period.
 * `THIS_WEEK`begins with Monday.
 */
var PredefinedTimePeriod;
(function (PredefinedTimePeriod) {
    /** Today. */
    PredefinedTimePeriod["TODAY"] = "TODAY";
    /** Yesterday. */
    PredefinedTimePeriod["YESTERDAY"] = "YESTERDAY";
    /** Last 7 days. */
    PredefinedTimePeriod["LAST_7_DAYS"] = "LAST_7_DAYS";
    /** Last 14 days. */
    PredefinedTimePeriod["LAST_14_DAYS"] = "LAST_14_DAYS";
    /** Last 30 days. */
    PredefinedTimePeriod["LAST_30_DAYS"] = "LAST_30_DAYS";
    /** Last 90 days. */
    PredefinedTimePeriod["LAST_90_DAYS"] = "LAST_90_DAYS";
    /** Last 28 days. */
    PredefinedTimePeriod["LAST_28_DAYS"] = "LAST_28_DAYS";
    /** Last 180 days. */
    PredefinedTimePeriod["LAST_180_DAYS"] = "LAST_180_DAYS";
    /** Last 365 days. */
    PredefinedTimePeriod["LAST_365_DAYS"] = "LAST_365_DAYS";
    /** Current week, starting on Monday. */
    PredefinedTimePeriod["THIS_WEEK"] = "THIS_WEEK";
    /** Current month. */
    PredefinedTimePeriod["THIS_MONTH"] = "THIS_MONTH";
    /** Current quarter. */
    PredefinedTimePeriod["THIS_QUARTER"] = "THIS_QUARTER";
    /** This year. */
    PredefinedTimePeriod["THIS_YEAR"] = "THIS_YEAR";
    /** Last week (previous week). */
    PredefinedTimePeriod["LAST_WEEK"] = "LAST_WEEK";
    /** Last month. */
    PredefinedTimePeriod["LAST_MONTH"] = "LAST_MONTH";
    /** Last quarter. */
    PredefinedTimePeriod["LAST_QUARTER"] = "LAST_QUARTER";
    /** Last year. */
    PredefinedTimePeriod["LAST_YEAR"] = "LAST_YEAR";
    /** Last 12 months. */
    PredefinedTimePeriod["LAST_12_MONTHS"] = "LAST_12_MONTHS";
})(PredefinedTimePeriod || (exports.PredefinedTimePeriod = PredefinedTimePeriod = {}));
/** Funnel step. */
var FunnelStep;
(function (FunnelStep) {
    /** Not selected. */
    FunnelStep["NOT_SELECTED_FUNNEL_STEP"] = "NOT_SELECTED_FUNNEL_STEP";
    /** Site sessions. */
    FunnelStep["SITE_SESSIONS"] = "SITE_SESSIONS";
    /** Viewed product. */
    FunnelStep["VIEWED_PRODUCT"] = "VIEWED_PRODUCT";
    /** Added to cart. */
    FunnelStep["ADDED_TO_CART"] = "ADDED_TO_CART";
    /** Reached checkout. */
    FunnelStep["REACHED_CHECKOUT"] = "REACHED_CHECKOUT";
    /** Sessions converted. */
    FunnelStep["SESSIONS_CONVERTED"] = "SESSIONS_CONVERTED";
})(FunnelStep || (exports.FunnelStep = FunnelStep = {}));
/** Device type. */
var DeviceType;
(function (DeviceType) {
    /** Not selected. */
    DeviceType["NOT_SELECTED_DEVICE_TYPE"] = "NOT_SELECTED_DEVICE_TYPE";
    /** Desktop. */
    DeviceType["DESKTOP"] = "DESKTOP";
    /** Mobile. */
    DeviceType["MOBILE"] = "MOBILE";
    /** Tablet. */
    DeviceType["TABLET"] = "TABLET";
    /** All. */
    DeviceType["ALL"] = "ALL";
})(DeviceType || (exports.DeviceType = DeviceType = {}));
/** Job status. */
var JobStatus;
(function (JobStatus) {
    /** Unknown. */
    JobStatus["UNKNOWN_JOB_STATUS"] = "UNKNOWN_JOB_STATUS";
    /** In progress. */
    JobStatus["IN_PROGRESS"] = "IN_PROGRESS";
    /** Finished. */
    JobStatus["FINISHED"] = "FINISHED";
    /** Error. */
    JobStatus["ERROR"] = "ERROR";
})(JobStatus || (exports.JobStatus = JobStatus = {}));
/**
 * Start an async job to retrieve a list of session IDs, given the specified filters. The following filters **must** be passed:
 * - Time period, either predefined or custom.
 * - Session filter, either navigation flow (page interactions), conversion funnel steps, or device type.
 * @public
 * @requiredField options.params
 * @requiredField options.period
 * @param options - Filter options. The following filters **must** be passed:
 *
 *  - Time period, either predefined or custom.
 *
 *  - Session filter, either navigation flow (page interactions), conversion funnel steps, or device type.
 * @permissionId ANALYTICS_AND_REPORTS.SESSIONS_READ
 * @permissionScope Manage Session Recording Analytics - all permissions
 * @permissionScopeId SCOPE.DC-ANALYTICS-AND-REPORTS.MANAGE-SESSIONS
 * @applicableIdentity APP
 * @returns List sessions async response.
 * @fqn wix.analytics_ng.session_ids.v1.SessionIdsService.ListSessionsAsync
 */
async function listSessionsAsync(options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        customTimePeriod: options?.customTimePeriod,
        predefinedTimePeriod: options?.predefinedTimePeriod,
        timezone: options?.timezone,
        navigationFlow: options?.navigationFlow,
        conversionFunnel: options?.conversionFunnel,
        deviceType: options?.deviceType,
    });
    const reqOpts = ambassadorWixAnalyticsNgV1Session.listSessionsAsync(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                customTimePeriod: '$[0].customTimePeriod',
                predefinedTimePeriod: '$[0].predefinedTimePeriod',
                timezone: '$[0].timezone',
                navigationFlow: '$[0].navigationFlow',
                conversionFunnel: '$[0].conversionFunnel',
                deviceType: '$[0].deviceType',
            },
            singleArgumentUnchanged: false,
        }, ['options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.listSessionsAsync = listSessionsAsync;
/**
 * Retrieves the job status and a list of session IDs, if ready.
 * @param jobId - List sessions job ID.
 * @public
 * @requiredField jobId
 * @requiredField options
 * @requiredField options.limit
 * @requiredField options.offset
 * @param options - Field options. The `limit` and `offset` filters **must** be passed.
 * @permissionId ANALYTICS_AND_REPORTS.SESSIONS_READ
 * @permissionScope Manage Session Recording Analytics - all permissions
 * @permissionScopeId SCOPE.DC-ANALYTICS-AND-REPORTS.MANAGE-SESSIONS
 * @applicableIdentity APP
 * @returns Get list sessions job result response.
 * @fqn wix.analytics_ng.session_ids.v1.SessionIdsService.GetListSessionsJobResult
 */
async function getListSessionsJobResult(jobId, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        jobId: jobId,
        limit: options?.limit,
        offset: options?.offset,
    });
    const reqOpts = ambassadorWixAnalyticsNgV1Session.getListSessionsJobResult(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                jobId: '$[0]',
                limit: '$[1].limit',
                offset: '$[1].offset',
            },
            singleArgumentUnchanged: false,
        }, ['jobId', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.getListSessionsJobResult = getListSessionsJobResult;
/**
 * Marks a browser session as recorded.
 * @param sessionId - Browser session ID.
 * @public
 * @requiredField sessionId
 * @permissionId ANALYTICS_AND_REPORTS.SESSIONS_UPDATE
 * @permissionScope Manage Session Recording Analytics - all permissions
 * @permissionScopeId SCOPE.DC-ANALYTICS-AND-REPORTS.MANAGE-SESSIONS
 * @applicableIdentity APP
 * @returns Mark a browser session as recorded.
 * @fqn wix.analytics_ng.session_ids.v1.SessionIdsService.MarkSessionAsRecorded
 */
async function markSessionAsRecorded(sessionId) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        sessionId: sessionId,
    });
    const reqOpts = ambassadorWixAnalyticsNgV1Session.markSessionAsRecorded(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { sessionId: '$[0]' },
            singleArgumentUnchanged: false,
        }, ['sessionId']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.markSessionAsRecorded = markSessionAsRecorded;
/**
 * Marks browser session recordings as deleted.
 * @param sessionIds - Browser session IDs.
 * @public
 * @requiredField sessionIds
 * @permissionId ANALYTICS_AND_REPORTS.SESSIONS_UPDATE
 * @permissionScope Manage Session Recording Analytics - all permissions
 * @permissionScopeId SCOPE.DC-ANALYTICS-AND-REPORTS.MANAGE-SESSIONS
 * @applicableIdentity APP
 * @returns Marks browser session recordings as deleted.
 * @fqn wix.analytics_ng.session_ids.v1.SessionIdsService.MarkRecordingsAsDeleted
 */
async function markRecordingsAsDeleted(sessionIds) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        sessionIds: sessionIds,
    });
    const reqOpts = ambassadorWixAnalyticsNgV1Session.markRecordingsAsDeleted(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { sessionIds: '$[0]' },
            singleArgumentUnchanged: false,
        }, ['sessionIds']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.markRecordingsAsDeleted = markRecordingsAsDeleted;
//# sourceMappingURL=analytics-ng-v1-session-analytics-session.universal.js.map